//Piano_TCP.Bas
//works with Protocol_Main.Spin
//but over the LAN or internet
TCPS_IP = "192.168.0.196" \ TCPS_Port = 50001
tcpc_Connect(TCPS_IP,TCPS_Port)
Port = 16  //change this as per your system
#include ".\Instruments.Bas"
//--------------------------------------------
Main:
   GoSub Initialization
   while true
      call CheckMouse()   
      while PlayTune
         call Play_Tune(Tempo)
      wend
   wend
end
//=======================================================
//=======================================================
Initialization:
   GoSub SetUpNotes
   GoSub SetUp_Jingles
   clearscr gray
   WOffset = 50 \ WW=20
   for i=0 to 7*5-1  //draw the normal keys
      rectanglewh WOffset+WW*i,100,WW,100,rgb(0,0,50)
   next
   BW = 14 \ BOffset = 63
   for i=0 to 7*5-1  //draw the sharp keys
      rectanglewh BOffset+WW*i,100,BW,50,black,black
      if i#7 == 1 || i#7 == 5 then i++  //some sharps are not allowed
   next
   data NoteMap; 0,2,4,5,7,9,11
   data SharpMap; 1,3,0,6,8,10
   //setcommport Port,br115200
   //clearserbuffer
   PlayTune = false
   AddButton "&Jingle Bells",500,20
   onButton bHandler
Return
//===============================================================
sub bHandler()  //button interrupt handler
   lb = LastButton()
   if left(lb,3) == "&Ji"
      RenameButton lb,"&Stop"
      _PlayTune = true
   else
      RenameButton lb,"&Jingle Bells"
      _PlayTune = false
   endif
   onbutton bHandler
return
//===============================================================
SetUpNotes: //frequencies array
   data Notes;0
   data Notes;32.703,34.648,36.708,38.891,41.203,43.654
   data Notes;46.249,48.999,51.913,55.0,58.27,61.735
   
   data Notes;65.406,69.296,73.416,77.782,82.407,87.307
   data Notes;92.499,97.999,103.83,110.0,116.54,123.47
   
   data Notes;130.81,138.59,146.83,155.56,164.1,174.61
   data Notes;185.0,196.0,207.65,220.0,233.08,246.94
   
   data Notes;261.63,277.18,293.66,311.13,329.63,349.23    'middle C
   data Notes;369.99,391.99,415.31,440.0,466.16,493.88
   
   data Notes;523.25,554.37,587.33,622.25,659.26,698.46
   data Notes;739.99,783.99,830.61,880.0,932.33,987.77
   
   data Notes;1046.5,1108.7,1174.7,1244.5,1318.5,1396.9
   data Notes;1480.0,1568.0,1661.2,1760.0,1864.7,1975.5
   
   data Notes;2093.0,2217.5,2349.3,2489.0,2637.0,2793.8
   data Notes;2960.0,3136.0,3322.4,3520.0,3729.3,3951.1
   
   
   S=-2 \ P=-1\ C=0 \ CS=1 \ D=2 \ DS=3 \ E=4
   F=5 \ FS=6 \ G=7 \ GS=8 \ A=9 \ AS=10 \ B=11
Return
//===============================================================
SetUp_Jingles: //RTTTL codes for the tune
   Tempo = 1500 
   data Song;S,5,E,8,E,8,P,32,E,4,P,32,E,8,E,8,P,32,E,4,P,32
   data Song;E,8,G,8,P,32,C,4,D,16,P,32,E,2,P,16
   data Song;F,8,F,8,P,32,F,8,F,16,P,32,F,8,E,8,P,32
   data Song;E,8,E,16,P,32,G,8,G,8,F,8,D,8,P,32,C,2
Return
//===============================================================
sub Play_Tune(Tempo)  //play all the notes in the tune's list
  Scale = 4
  FOR i = 0 TO MaxDim(Song,1)-1 step 2
     if Song[i] = _P  //if a pause
       Note = 0
       Duration = Tempo/Song[i+1]
     elseif Song[i] = _S   //if scale change
       Scale = Song[i+1]
       continue
     else
       Note = Song[i]+12*Scale+1    //determine the note number
       Duration = Tempo/Song[i+1]   //determine duration from tempo
     endif
     call PlayNote(Note,Duration)
     if !_PlayTune || !PlayNote__Result then _PlayTune = false \ break
  next
Return
//===============================================================
sub PlayNote(N,D,&s)
   xystring 1,1,"Note = ",Notes[N];"Duration = ",D,spaces(10) //display data
   s ="" \ c = 5
   if _Port == 0        //if not serial
     //sound Notes[N],D   //play on PC speaker...only XP machines
   else                  
     //serialout 73,N     //send the command and note number
     call TCP_SendCommand(73,N,s,c)
     delay D            //delay
     //serbytesin 5,s,c   
     if c == 5 then B = getstrbyte(s,1) //get the value of the P5 button state
      if (B) & 0%001  //the buttons are active high and P5 is the LSBit
          if _PlayTune
             RenameButton "&Stop","&Jingle Bells"
          else
             RenameButton "&Jingle Bells","&Stop"
          endif
          _PlayTune = ! _PlayTune
          delay 200  //delay to eliminate button bounce
      endif

   endif   
Return (c==5) //return true or false if 5 bytes received
//===============================================================  
sub CheckMouse() //determine which key is pushed
     readmouse x,y,b                         //read mouse
     if !b then call PlayNote(0,1) \ return  //if no click then no sound
     c = pixelclr(x,y)                       //get the color under the mouse
     if c == white
       x = (x-_WOffset)/_WW                  //convert x to key number
       Scale = 1+x/7 \ Note = NoteMap[x#7]   //convert to note number and scale
     elseif c == black  
       x = (x-_BOffset)/_WW                  //convert to key number 
       Scale = 1+x/7 \ Note = SharpMap[x#7]  //convert to note number and scale
     endif
     if c == white || c == Black             //if there is a note
         Frequency = Note+12*Scale+1         //get its number
         call PlayNote(Frequency,100)        //play it
     endif    
Return
//===============================================================  

